"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.buildUrl = void 0;
const ramda_1 = require("ramda");
const utils_1 = require("@procyon/utils");
const buildUrl = (url, params) => {
    let queryParams = Object.assign({}, params);
    let replacedUrl = url;
    if (params !== undefined) {
        (0, ramda_1.mapObjIndexed)((value, name) => {
            if ((0, ramda_1.includes)(`{${name}}`, url)) {
                queryParams = (0, ramda_1.dissoc)(name, queryParams);
                replacedUrl = (0, ramda_1.replace)(`{${name}}`, value, replacedUrl);
            }
        })(params);
    }
    if (!(0, utils_1.isNilOrEmpty)(queryParams)) {
        return `${replacedUrl}?${Object.keys(queryParams)
            .map((k) => encodeURIComponent(k) + '=' + encodeURIComponent(queryParams[k]))
            .join('&')}`;
    }
    return replacedUrl;
};
exports.buildUrl = buildUrl;
